//+------------------------------------------------------------------+
//|                                        Super-MTF-bears-bulls.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#define NA 0
#define BUY 1
#define SELL 2
extern color FontColor = Yellow;
extern color BuyVLineColor = Red;
extern color SellVLineColor = Blue;
extern bool Draw = false;
extern bool MN = true;
extern bool W1 = true;
extern bool D1 = true;
extern bool H4 = true;
extern bool H1 = true;
extern bool M30 = true;
extern bool M15 = true;
extern bool M5 = true;
extern bool M1 = false;
static datetime Bar1Time;
int tUp, tDown;
int Up, Down;
int Signal;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   //heading
   TextLabel("TextLabel_0", "M1 M5 M15 M30 H1 H4 D1 W1 MN", 8, "Arial", FontColor, 1, 8, 12, 0);
   //columns
   TextLabel("TextLabel_1", "6", 14, "Wingdings", FontColor, 1, 157, 23, 0);//m1
   TextLabel("TextLabel_2", "6", 14, "Wingdings", FontColor, 1, 138, 23, 0);//m5
   TextLabel("TextLabel_3", "6", 14, "Wingdings", FontColor, 1, 118, 23, 0);//m15
   TextLabel("TextLabel_4", "6", 14, "Wingdings", FontColor, 1, 97, 23, 0);//m30
   TextLabel("TextLabel_5", "6", 14, "Wingdings", FontColor, 1, 78, 23, 0);//h1
   TextLabel("TextLabel_6", "6", 14, "Wingdings", FontColor, 1, 61, 23, 0);//h4
   TextLabel("TextLabel_7", "6", 14, "Wingdings", FontColor, 1, 46, 23, 0);//d1
   TextLabel("TextLabel_8", "6", 14, "Wingdings", FontColor, 1, 28, 23, 0);//w1
   TextLabel("TextLabel_9", "6", 14, "Wingdings", FontColor, 1, 9, 23, 0);//mn
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   //Signal=NA;
//---
   //mn
     if(MN)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,43200,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,43200,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,43200,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,43200,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_9", "", 14, "Wingdings", FontColor, 1, 9, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_9", "", 14, "Wingdings", FontColor, 1, 9, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_9", "", 14, "Wingdings", FontColor, 1, 9, 23, 0);}
     }
   //w1
     if(W1)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,10080,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,10080,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,10080,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,10080,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_8", "", 14, "Wingdings", FontColor, 1, 28, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_8", "", 14, "Wingdings", FontColor, 1, 28, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_8", "", 14, "Wingdings", FontColor, 1, 28, 23, 0);}
     }
   //d1
     if(D1)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,1440,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,1440,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,1440,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,1440,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_7", "", 14, "Wingdings", FontColor, 1, 46, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_7", "", 14, "Wingdings", FontColor, 1, 46, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_7", "", 14, "Wingdings", FontColor, 1, 46, 23, 0);}
     }
   //h4
     if(H4)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,240,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,240,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,240,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,240,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_6", "", 14, "Wingdings", FontColor, 1, 61, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_6", "", 14, "Wingdings", FontColor, 1, 61, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_6", "", 14, "Wingdings", FontColor, 1, 61, 23, 0);}
     }
   //h1
     if(H1)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,60,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,60,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,60,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,60,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_5", "", 14, "Wingdings", FontColor, 1, 78, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_5", "", 14, "Wingdings", FontColor, 1, 78, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_5", "", 14, "Wingdings", FontColor, 1, 78, 23, 0);}
     }
   //m30
     if(M30)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,30,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,30,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,30,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,30,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_4", "", 14, "Wingdings", FontColor, 1, 97, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_4", "", 14, "Wingdings", FontColor, 1, 97, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_4", "", 14, "Wingdings", FontColor, 1, 97, 23, 0);}
     }
   //m15
     if(M15)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,15,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,15,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,15,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,15,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_3", "", 14, "Wingdings", FontColor, 1, 118, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_3", "", 14, "Wingdings", FontColor, 1, 118, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_3", "", 14, "Wingdings", FontColor, 1, 118, 23, 0);}
     }
   //m5
     if(M5)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,5,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,5,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,5,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,5,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_2", "", 14, "Wingdings", FontColor, 1, 138, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_2", "", 14, "Wingdings", FontColor, 1, 138, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_2", "", 14, "Wingdings", FontColor, 1, 138, 23, 0);}
     }
   //m1
     if(M1)
     {
     Up=0;  Down=0;
     if(iBearsPower(NULL,1,13,2,0)>0){Up++;}else{Down++;}//high bears
     if(iBearsPower(NULL,1,13,3,0)>0){Up++;}else{Down++;}//low bears
     if(iBullsPower(NULL,1,13,2,0)>0){Up++;}else{Down++;}//high bulls
     if(iBullsPower(NULL,1,13,3,0)>0){Up++;}else{Down++;}//low bulls
     tUp=+Up; tDown=+Down;
     if(Up==Down){TextLabel("TextLabel_1", "", 14, "Wingdings", FontColor, 1, 157, 23, 0);}
     if(Up>Down){TextLabel("TextLabel_1", "", 14, "Wingdings", FontColor, 1, 157, 23, 0);}
     if(Up<Down){TextLabel("TextLabel_1", "", 14, "Wingdings", FontColor, 1, 157, 23, 0);}
     }
   //--
   //footer
   TextLabel("TextLabel_10", "MTF Signal:", 14, "Arial", FontColor, 1, 73, 46, 0);
   //--bars--
   if(Bar1Time!=Time[1])
   {
   Bar1Time=Time[1];
   if(Draw)
      {
      if(tUp==tDown && Signal!=NA)
         {
         Signal=NA; PlaySound("wait.wav");
         TextLabel("TextLabel_11", "DRAW", 14, "Arial", FontColor, 1, 12, 46, 0);
         }      
      }
   if(tUp>tDown && Signal!=BUY)
      {
      Signal=BUY; PlaySound("news.wav"); VerticalLine("VerticalLine_" + IntegerToString(Time[0]),True);
      TextLabel("TextLabel_11", "LONG", 14, "Arial", FontColor, 1, 12, 46, 0);
      }
   if(tUp<tDown && Signal!=SELL)
      {
      Signal=SELL; PlaySound("news.wav"); VerticalLine("VerticalLine_" + IntegerToString(Time[0]),False);
      TextLabel("TextLabel_11", "SELL", 14, "Arial", FontColor, 1, 12, 46, 0);
      }
   }
   //--bars--
   Print("MTF Up Signals:" + IntegerToString(tUp) + ", Down Signals:" + IntegerToString(tDown));
   tUp=0; tDown=0;
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//
//
//+------------------------------------------------------------------+
//| Draw Vertical Lines
//| = VerticalLine(VerticalLine_1,True) 
//+------------------------------------------------------------------+
void VerticalLine(string Name2, bool buy) 
   { 
   if(buy) 
      { 
      ObjectCreate(Name2,OBJ_VLINE,0,Time[0],Ask); 
      ObjectSet(Name2,OBJPROP_COLOR,BuyVLineColor);
      ObjectSet(Name2,OBJPROP_STYLE,3); 
      ObjectSet(Name2,OBJPROP_WIDTH,0); 
      ObjectSet(Name2,OBJPROP_BACK,true); 
      }
   else 
      { 
      ObjectCreate(Name2,OBJ_VLINE,0,Time[0],Bid); 
      ObjectSet(Name2,OBJPROP_COLOR,SellVLineColor);
      ObjectSet(Name2,OBJPROP_STYLE,3); 
      ObjectSet(Name2,OBJPROP_WIDTH,0); 
      ObjectSet(Name2,OBJPROP_BACK,true); 
      }
   }
//+------------------------------------------------------------------+
//
//
//+------------------------------------------------------------------+
//| TEXT LABEL                                                       |
//| = TextLabel("TextLabel_1", "Text 1", 8, "Arial", Lime, 1, 56, 21, 0);
//+------------------------------------------------------------------+
void TextLabel(string Name, string Text, int Size, string Font, color Color, int Corner, int Xcor, int Ycor, int Angle)
   {
   //Upper left=0, Upper right=1, Lower left=2, Lower right=3
   ObjectCreate(Name,OBJ_LABEL,0,0,0);
   ObjectSetText(Name, Text, Size, Font, Color);
   ObjectSet(Name, OBJPROP_CORNER, Corner); 
   ObjectSet(Name, OBJPROP_XDISTANCE, Xcor);
   ObjectSet(Name, OBJPROP_YDISTANCE, Ycor);
   ObjectSet(Name, OBJPROP_ANGLE,Angle);
   }
//+------------------------------------------------------------------+